# Generated by Django 3.1.3 on 2021-01-31 15:44

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import secrets


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Certificate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('serial_number', models.BinaryField(max_length=20)),
                ('pem', models.TextField()),
                ('created', models.DateTimeField(auto_now_add=True)),
            ],
        ),
        migrations.CreateModel(
            name='CertificationAuthority',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('key_pem', models.TextField(blank=True, null=True)),
                ('comment', models.CharField(max_length=128)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('public', models.BooleanField(default=False)),
                ('admin', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='certification_authorities', to=settings.AUTH_USER_MODEL)),
                ('cert', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='owlca.certificate')),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='children', to='owlca.certificationauthority')),
            ],
        ),
        migrations.CreateModel(
            name='CertificateSigningRequest',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('pem', models.TextField()),
                ('retrieve_code', models.CharField(default=secrets.token_urlsafe, max_length=64)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('verification', models.IntegerField(choices=[(0, 'Verification of the CSR is pending'), (10, 'Verification succeeded'), (20, 'Verification failed')], default=0, verbose_name='Verification status')),
                ('ca', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='requests', to='owlca.certificationauthority')),
            ],
        ),
        migrations.AddField(
            model_name='certificate',
            name='ca',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='issued_certificates', to='owlca.certificationauthority'),
        ),
        migrations.AddField(
            model_name='certificate',
            name='request',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='certificates', to='owlca.certificatesigningrequest'),
        ),
    ]
